| Home | Libraries | People | FAQ | More

#### read_at (1 of 8 overloads)

Attempt to read a certain amount of data at the specified offset before returning.

    template<
        typename SyncRandomAccessReadDevice,
        typename MutableBufferSequence>
    std::size_t read_at(
        SyncRandomAccessReadDevice & d,
        boost::uint64_t offset,
        const MutableBufferSequence & buffers);

This function is used to read a certain number of bytes of data from a random access device at the specified offset. The call will block until one of the following conditions is true:

- The supplied buffers are full. That is, the bytes transferred is equal to the sum of the buffer sizes.
- An error occurred.

This operation is implemented in terms of zero or more calls to the device's read_some_at function.

###### Parameters

d

  The device from which the data is to be read. The type must support the SyncRandomAccessReadDevice concept.

offset

  The offset at which the data will be read.

buffers

  One or more buffers into which the data will be read. The sum of the buffer sizes indicates the maximum number of bytes to read from the device.

###### Return Value

The number of bytes transferred.

###### Exceptions

boost::system::system_error

  Thrown on failure.

###### Example

To read into a single data buffer use the `buffer` function as follows:

    boost::asio::read_at(d, 42, boost::asio::buffer(data, size));

See the `buffer` documentation for information on reading into multiple buffers in one go, and how to use it with arrays, boost::array or std::vector.

###### Remarks

This overload is equivalent to calling:

    boost::asio::read_at(
        d, 42, buffers,
        boost::asio::transfer_all());